#include "../../../lib/std.mi"


// Functions
//------------------------------------------------------------
Function updateVolume(int v);
Function initVolume();
Function initSticker();

// Globals
//------------------------------------------------------------
Global Group		PlayerCtrls;
Global AnimatedLayer	Volume;
Global Layer		VolumeInfo;
Global Map			volMap;
Global Boolean		InUse=0;
Global Timer		StickerTimer;
Global Text			TimerSticker;
Global Slider		HiddenVolume;
Global Int 			VolChanging, VolFrames, VolFlag;
Global Int 			StickerExist;

Global Button		BVolume;
Global Slider		SongSeeker;
Global Layer		SongSeekbg;

Global Int			IsVolume;


// onload
//------------------------------------------------------------
System.onScriptLoaded() {

	IsVolume = 0;

	volMap = new Map;
	volMap.loadMap("player.map.volume");

	PlayerCtrls = System.getContainer("main").getLayout("normal").getObject("player.control");

	Volume = PlayerCtrls.getObject("VolumeAnim");
	VolumeInfo = PlayerCtrls.getObject("volumeaniminfo");
	HiddenVolume = PlayerCtrls.getObject("HiddenVolume");

	BVolume = PlayerCtrls.getObject("BVolume");
	SongSeeker = PlayerCtrls.getObject("Seeker");
	SongSeekbg = PlayerCtrls.getObject("Seekbg");

	initVolume();

	Volume.hide();
	VolumeInfo.hide();
}

// Volume Button
//------------------------------------------------------------
BVolume.onLeftClick() {
	if (IsVolume) {
		SongSeeker.SetAlpha(255);
		SongSeekbg.show();
		Volume.hide();
		VolumeInfo.hide();
		IsVolume = 0;
	} else {
		SongSeeker.SetAlpha(0);
		SongSeekbg.hide();
		Volume.show();
		VolumeInfo.show();
		IsVolume = 1;
	}
}


// Initialzes song ticker
//------------------------------------------------------------
initSticker() {
	TimerSticker = System.getContainer("main").getLayout("normal").getObject("timer");

	StickerTimer = new Timer;
	StickerTimer.setDelay(1000);
}



// Clears text area
//------------------------------------------------------------
StickerTimer.onTimer() {
	TimerSticker.setText("");
	StickerTimer.stop();
}



// Initializes volume anim
//------------------------------------------------------------
initVolume() {

	VolumeInfo.setAlpha(0);

	VolChanging = 0;
	VolFlag = 0;
	VolFrames = Volume.getLength();
	VolFrames = VolFrames - 1;
	StickerExist = VolumeInfo.getTop();

	float u;
	u = System.getVolume();
	u = u / 255;
	int k = u * VolFrames;
	Volume.gotoFrame(k);

	if (StickerExist) initSticker();
}




//------------------------------------------------------------
// Volume functions
//------------------------------------------------------------

Volume.onMouseMove(int x, int y) {
	if (VolChanging) 
	{
		x = x - Volume.getLeft();
		y = y - Volume.getTop();
		if (volMap.inRegion(x, y)) { 
			float v = volMap.getValue(x, y);
			if (!VolFlag) { 
				updateVolume(v); 
				if (v > 250) { 
				VolFlag = 2;
				updateVolume(255);
				}
				if (v < 5) { 
				VolFlag = 1;
				updateVolume(0);
				}
			}
			else {
				if ((VolFlag == 2) && (v > 120) && (v < 252)) VolFlag = 0;
				if ((VolFlag == 1) && (v < 120) && (v > 2)) VolFlag = 0;
			}
		}
	}
}


Volume.onLeftButtonDown(int x, int y) {
	VolChanging = 1;
}


Volume.onLeftButtonUp(int x, int y) {
	if (VolChanging) {
		x = x - Volume.getLeft();
		y = y - Volume.getTop();
		if (volMap.inRegion(x, y)) { 
			float v = volMap.getValue(x, y);
			if (!VolFlag) { 
				updateVolume(v); 
				if (v > 250) { 
					VolFlag = 2;
					updateVolume(255);
				}
				if (v < 5) { 
					VolFlag = 1;
					updateVolume(0);
				}
			}
			else {
					if ((VolFlag == 2) && (v > 120) && (v < 252)) VolFlag = 0;
					if ((VolFlag == 1) && (v < 120) && (v > 2)) VolFlag = 0;
				}
			}
			VolChanging = 0;
	}
}






updateVolume(float v) {
	if (v >= 0)
	{
		float k = v / 255;
		int g = k * VolFrames;
		Volume.gotoFrame(g);
		System.setVolume(v); 
		int p = k * 100;

		StickerTimer.stop();
		StickerTimer.start();
		TimerSticker.setText(System.integerToString(p) + "%");
	}
}

// Reads System Volume Changes
HiddenVolume.onPostedPosition(int p) {
	if (!VolChanging) {
		Float f = getVolume();
		Float sf = f/2.55;
		f = f * VolFrames;
		f = f / 255;
		Volume.gotoFrame(f);		

		StickerTimer.stop();
		StickerTimer.start();
		TimerSticker.setText(System.integerToString(sf) + "%");		
	}
}

//------------------------------------------------------------
// End of Volume functions
//------------------------------------------------------------

